//linked<animated*> linked_hud;		//head up display
//array<unsigned char> *fntt;			//target font
//animated *ani_select;						//just a pointer

//------------------------------------------------------------------------
// CAMERA: control acts as the main function which also sets glModelView (!)
// has by default collision mesh of a sphere
// at the moment camera has to many functions sorry!!!
//------------------------------------------------------------------------
class aniCamera : public animated {
	public:
		aniCamera(void) : animated() {};			//construct
		//~aniCamera(void);
		//void control(void);		//obligatory, calls glMultMatrix finally
		//void flush(void);     //glMultMatrixf(important!!!) call after everything has motion()ed before everything is draw()n
		void draw(void) {};   //nada
		//void pickup(animated *a); //puts object from world into camera space and appends it to hud list
		//void hud(void);				//displays objects from hud list and info about current humanized obj (speed etc)
		//void setCarrier(animated *a) { //only called once usually						
		//	bool dirty=true;
		//	if (ani) {
		//		ani->index&=ANI_ALL^ANI_HUMANIZED; //DE!humanizes previous obj			
		//		if (!ani->is(ANI_CAMERA_INS)) dirty=false;
		//	}
		//	ani=a;
		//	ani->index|=ANI_HUMANIZED;
		//	setLook(~ANI_CAMERA_SET&ani->index,dirty);
		//}
		//void setOffset(void); //sets desired offsets opos/ocat
		//matrix<float> *view;	//smooth mouse glimpse		
		//matrix<float> *cat;		//world look at
		//matrix<float> *opos;  //should posisions
		//matrix<float> *ocat;		
		animated* carrier;
	private:
		//void select(void); //only called from hud/ better structured that a way/ maybe soon gone :-)		
		//void setLook(int cam,bool dirty) {
		//	if (ani->is(ANI_CAMERA_INS)) dirty=true;  //need to set camera
		//	ani->index=ani->index&ANI_CAMERA_SET|cam;
		//	setOffset();
		//	if (dirty) {
		//		*mat=ani->getMat()*glTranslate(*opos^0);
		//		*cat=ani->getMat()**ocat;
		//	}
		//}
		//ani_collide *cld_backup;
};

//aniCamera* aniCamera::instance=new aniCamera();

/*
void aniCamera::setOffset(void) {
	//default values
	if (ani->is(ANI_CAMERA_INS)) {*opos<=0<=0<= 0<=1; *ocat<=0<=0<=-1<=1;}
	if (ani->is(ANI_CAMERA_2D )) {*opos<=0<=2<=16<=1; *ocat<=0<=1<=-1<=1;}
	if (ani->is(ANI_CAMERA_3D )) {*opos<=0<=2<= 7<=1; *ocat<=0<=1<=-1<=1;}
	//specialized
	if (ani->is(ANI_APACHE)) {
		if (ani->is(ANI_CAMERA_2D )) {*opos<=0<=3<=20<=1; *ocat<=0<=1<=-2<=1; }		
	}
	
	if (ani->is(ANI_CAMERA_INS)) {
		if (ani->is(ANI_BOMBER )) *opos<= 0 <= 1 <= 0 <=1;
		if (ani->is(ANI_MUSTANG)) *opos<=-.5<= .6<=-.2<=1;
	}
}

aniCamera* aniCamera::instance=NULL;

aniCamera::aniCamera(void) : animated() {		
	setMassAndG(1,1);	
	cld=cld_backup=loadCollide("data/sphere1",ANI_HEAVY); //not yet deleted because usually taken from global resources!!!
	ani=NULL; //please call setCarrier() with to be animated* initially
	view =new matrix<float>(2,3); //mouse
	cat  =new matrix<float>(4,1); //curr cam (look) at	(relative to object!)	
	opos =new matrix<float>(4,1);
	ocat =new matrix<float>(4,1);	
};
aniCamera::~aniCamera(void) {if (view&&cat&&opos&&ocat) delete view,cat,opos,ocat; };
void aniCamera::control() {//example: false for cars - true for planes	
	int c1;
	//F1-F3 change camera
	if (keys[1+KEY_SP+KEY_DOWN]&&!ani->is(ANI_CAMERA_INS)) setLook(ANI_CAMERA_INS,false);
	if (keys[2+KEY_SP+KEY_DOWN]&&!ani->is(ANI_CAMERA_2D )) setLook(ANI_CAMERA_2D ,false);
	if (keys[3+KEY_SP+KEY_DOWN]&&!ani->is(ANI_CAMERA_3D )) setLook(ANI_CAMERA_3D ,false);

	if (!ani->is(ANI_AVATAR))	{
		view->data[0]=(mouse[2]-mouse[4])*10; //mouse influence
		view->data[1]=(mouse[3]-mouse[5])*10;
		*view*=glIntegral(dt,10,7);
		glRotatef(view->data[4],1,0,0);
		glRotatef(view->data[5],0,1,0);
	};
	
	if (ani->is(ANI_CAMERA_INS)) {cld=NULL; return; } //(cam e.g. in car) has to be precise => glMult in flush()
	
	matrix<float> ref(4,4,"eye");
	matrix<float> wmat=ani->getMat();

	int mov=0;
	if (ani->is(ANI_CAMERA_2D)) { //car racing style		
		mov=2;
		matrix<float> prj(4,1);
			prj[0]=wmat[ 8];
			prj[2]=wmat[10];
			prj.normalize(2);	//"back" vector in xz-plane
		ref[0]= prj[2];
		ref[2]=-prj[0]; 		//make "back" vector rot90 x vector
		memcpy(ref^ 8, prj^ 0,12);
		memcpy(ref^12,wmat^12,12);		
	}
	if (ani->is(ANI_CAMERA_3D)) {//DECENT style		
		mov=3;
		ref=wmat;
	}
	if (mov) {
		cld=cld_backup;
		//old mouse 
		matrix<float> des=ref**opos; //compute desired world position
		matrix<float> cam(4,1); memcpy(cam.data,&mat->data[12],16);
		matrix<float> dif=cam-des;
		matrix<float> ndif=dif; ndif.normalize(2);
		ndif*=*tvel|ndif;
		dif+=ndif*.0707;
		*tforce-=dif;
		float stf=6;
		float lam=MAX<float>(1-stf*dt+stf*stf*dt2*.5,0); //taylor for exp -stf*dt		
		matrix<float> tmp=wmat**ocat;
		*cat=*cat*lam+tmp*(1-lam);
		if (mov==2)
			gluLookAt(cam[0],cam[1],cam[2],
								cat->data[0],cat->data[1],cat->data[2],
								0,1,0);                   			
		if (mov==3)
			gluLookAt(cam[0],cam[1],cam[2],
								tmp[0],tmp[1],tmp[2],
								ref[4],ref[5],ref[6]);
	}	
	glGetFloatv(GL_MODELVIEW_MATRIX,mat->data);	*mat=mat->glInverse();	
};

void aniCamera::flush(void) {
	matrix<float> wmat=ani->getMat();
	if (ani->is(ANI_CAMERA_INS)) {
		wmat*=glTranslate(*opos^0);
		glMultMatrixf(wmat.glInverse().data);
		glGetFloatv(GL_MODELVIEW_MATRIX,mat->data);	*mat=mat->glInverse();
	}
	FSOUND_3D_Listener_SetAttributes(
		*mat^12,																	//pos
		*tvel^0,																	//vel
		mat->data[8],mat->data[9],mat->data[10],	//front (or back ?)
		mat->data[4],mat->data[5],mat->data[ 6]);	//up
		
#ifndef RELEASE_MODE
	char glt[80]; //display carriers world positions
	sprintf(glt,"%6.2f %6.2f %6.2f",wmat[12],wmat[13],wmat[14]);
	linked_label.append(new glLabelText(frame_w-170,frame_h-11,glt,fnt0));	
#endif
};

void aniCamera::select(void) {	
	char glt[3];
	if (ani_select) //draw selected
		if (ani_select->is(ANI_ONSCREEN)) {
			//sprintf(glt," !#$%%&'");
			sprintf(glt,"%c",33);
			glCout.space(&ani_select->getMat().data[12],glt,fntt);
		}
	matrix<float> pos(4,1,"");
	matrix<float> minv=project*getMat().glInverse(); 
	animated *an2;
	float pds,snd;
	int x,y,flag=0;		
	linked<animated*> screen_ani;
	screen_ani.next[2]=NULL;
	while (linked_ani.token(an2)) {
		if (an2->is(ANI_SELECTABLE)) {
			an2->index&=ANI_ALL^ANI_ONSCREEN; //set ANI_ONSCREEN to zero;
			memcpy(pos.data,&an2->mat->data[12],16);
			pos=minv*pos;
			if (pos.data[3]>.2) {
				pds=1/pos.data[3];
				pos.data[0]*=pds;
				pos.data[1]*=pds;
				if (pos.data[0]>-1&&pos.data[0]<1&&pos.data[1]>-1&&pos.data[1]<1) { // is on screen
					x=(pos.data[0]+1)*frame_w2;
					y=(pos.data[1]+1)*frame_h2;					
					glReadPixels(x,y,1,1,GL_DEPTH_COMPONENT,GL_FLOAT,&snd);
					snd=1-snd;
					if (snd>M_EPS) { //no div over zero
						snd=.09668469/snd;
						if (snd*pds>.9) {//relative tolerance ok							
							an2->index|=ANI_ONSCREEN;							
							screen_ani.append(an2);
							flag++;
							if (an2==ani_select) {
								screen_ani.next[2]=screen_ani.next[1];
								sprintf(glt," ");
								glCout.space(&an2->getMat().data[12],glt,fntt);
							}
						}
					}
				}
			}
		}
	}
	if (keys.data[13+KEY_DOWN]) {//selection
		if (screen_ani.next[0]) {//non empty
			if (screen_ani.next[2]) {//current on screen already				
				if (screen_ani.next[2]->next[0])
					ani_select=screen_ani.next[2]->next[0]->data;
				else 
					ani_select=screen_ani.next[0]->data;
			} else {
				ani_select=screen_ani.next[0]->data;
			}
		} else 
			ani_select=NULL;
	}
	if (ani_select&&keys.data['+'+KEY_DOWN]) {
		ani->index&=ANI_ALL^ANI_HUMANIZED;
		ani=ani_select;
		if (ani->is(ANI_HUMANIZABLE)) ani->index|=ANI_HUMANIZED;
		ani_select=NULL;
	}
};
void aniCamera::pickup(animated *ani) {
	ani->time[1]=ANI_PRESERVED; //die, but you shall die not
	*ani->mat=mat->glInverse()*ani->getMat();
	*ani->rvel*=0;
	*ani->tvel*=0;
	ani->ofric->data[0]=3;
	ani->ofric->data[1]=3;
	ani->ofric->data[2]=3;
	ani->G=0;
	linked_hud.append(ani);
};
void aniCamera::hud(void) {//headupdisplay has its own animated list and here operates on it
	select();
	glDisable(GL_DEPTH_TEST);
	glLoadIdentity();
	animated *an2;
	while (linked_hud.token(an2)) {
		an2->rforce->data[0]= .5;
		an2->rforce->data[1]=1;		
		memcpy(an2->tforce->data,&((glTranslate(3,2,-5)-an2->getMat())*3).data[12],12);
		an2->motion();
		glPushMatrix();
			glMultMatrixf(an2->getMat().data);
			an2->draw();
		glPopMatrix();
	}
	if (ani->is(ANI_HASPANEL)) {
		matrix<float> wmat=ani->getMat();
		matrix<float> minv=wmat.glInverse();
		char glt[80];
		sprintf(glt,"wpos [%6.2f %6.2f %6.2f]",wmat[12],wmat[13],wmat[14]);
			linked_label.append(new glLabelText(0,50,glt,fnt0));
		matrix<float> ovel=minv**ani->tvel;
		sprintf(glt,"ovel [%6.2f %6.2f %6.2f]",ovel[0],ovel[1],ovel[2]);
			linked_label.append(new glLabelText(0,39,glt,fnt0));
	}
	glEnable(GL_DEPTH_TEST);	
};                

//--------------------------------------------------------------------------
//HELPER FUNCTIONS FOR DISPLAY PANEL
//--------------------------------------------------------------------------
//void scale3d(float fval,float fmin,float fmax) {
//	float p,w=.1,h=.01,t=.01;
//	p=2*w*(fval-fmin)/(fmax-fmin);
//	glLineWidth(4);	glColor3f(.9,.1,.9);
//	glBegin(GL_LINES);
//		glVertex3f(-w+p, h,0);
//		glVertex3f(-w+p,-h,0);
//	glEnd();
//	glLineWidth(2); glColor3f(.3,.3,.3);
//	glBegin(GL_LINE_STRIP);
//		glVertex3f(-w-t, h,0);
//		glVertex3f(+w+t, h,0);
//		glVertex3f(+w+t,-h,0);
//		glVertex3f(-w-t,-h,0);
//		glVertex3f(-w-t, h,0);
//	glEnd();
//};
//void circle3d(float r,float deg1,float deg2) {
//	float c1,d1,d2,dd;
//	glLineWidth(2); glColor3f(.3,.3,.3);	
//	d1=deg1*M_JPI*0.005555;
//	d2=deg2*M_JPI*0.005555;	
//	dd=(d2-d1)*.01;
//	glBegin(GL_LINE_STRIP);	
//	for (c1=d1;c1<d2;c1+=dd) glVertex3f(r*cos((double)c1),r*sin((double)c1),0);
//	glEnd();
//};
//void meter3d(float fval,float fmin,float fmax) {
//	double p,r=.1;	
//	p=M_JPI*1.25-(fval-fmin)/(fmax-fmin)*M_JPI*1.5;
//	glLineWidth(4);	glColor3f(.9,.1,.9);
//	glBegin(GL_LINES);
//		glVertex3f(0,0,0);
//		glVertex3f(r*cos(p),r*sin(p),0);
//	glEnd();
//	circle3d(r,-45,225);
//};
//void crosshair(animated *ani) {
//	glPushMatrix();
//	matrix<float> rot(4,4,"eye");
//	memcpy(rot.data,ani->mat->glInverse().data,48);
//	glTranslatef(-.5,.3,-1);
//	glMultMatrixf(rot.data);
//		glLineWidth(1);
//		glBegin(GL_LINES);
//			glNormal3f(0,1,0);
//			glColor3f(1,0,0); glVertex3f(0,0,0); glVertex3f(.1, 0, 0);
//			glColor3f(0,0,0); glVertex3f(0,0,0); glVertex3f( 0,.1, 0);
//			glColor3f(0,0,1); glVertex3f(0,0,0); glVertex3f( 0, 0,.1);
//		glEnd();			
//	glPopMatrix();
//};
*/
